%%%%%%%%%% Only for cubic model (odd)
clear;
clc
load Glass3DLog_14cube.mat;
MMM = zeros(15,15,15);
MMM(1:14,1:14,1:14) = GGG;

Ssize = 15;
Tsize = 51;  

HSsize = (Ssize-1)/2;
Scenter = HSsize+1;
Tcenter = (Tsize+1)/2;
Od_cal = pi*(Tsize*Tsize) / (2*Ssize*Ssize*Ssize)

Rtot = zeros(Tsize,Tsize,Tsize);
Rtot(Tcenter-HSsize:Tcenter+HSsize,Tcenter-HSsize:Tcenter+HSsize,Tcenter-HSsize:Tcenter+HSsize) = MMM;

Fktot = fftshift(fftn(Rtot));
Ftot = abs(Fktot);

%%%%%%%%%% Count k-points in the shell
Mcount = zeros(Tsize,Tsize,Tsize);
thickness = 1;
HT = thickness/2;
for a = 1:Tsize
    for b = 1:Tcenter
        for c = 1:Tsize
            if (sqrt((a-Tcenter)^2+(b-1)^2+(c-Tcenter)^2)<(Tcenter-1+HT))&(sqrt((a-Tcenter)^2+(b-1)^2+(c-Tcenter)^2)>(Tcenter-1-HT))
                Mcount(a,b,c) = 1;
            end
        end
    end
end
for l = 1:Tsize
    Mcount(:,Tcenter+1:Tsize,l) = fliplr(Mcount(:,1:Tcenter-1,l));
end

Kpointnum = sum(sum(sum(Mcount)))
Rhonum = Ssize*Ssize*Ssize
Od_real = Kpointnum / (2*Rhonum)

load Tsupp_15cube.mat
Rhoexact = sum(sum(sum(TTT)))
Od_exact =  Kpointnum / (2*sum(sum(sum(TTT))))
%%%%%%%%%%

Ftot(Mcount==0) = -1;
%%% The final input of function "HIO3D" = 1 is for perfect initial phase
[R3D_best Min_errorF] = HIO3D(Ftot,[Ssize Ssize Ssize],1000000,1,0);
Min_errorF
